﻿Option Strict On
Imports System.Windows.Media

Partial Public Class MainPage
    Inherits UserControl

    '前5色＋メインカラー1色＋後5色の計11個の検索キーを格納する，11個の配列を作成。
    Dim colorArea() As String = New String(11) {}

    'スライダーの中央値代入用の変数を宣言。
    Dim myValue_16 As String

    Public Sub New()
        InitializeComponent()
    End Sub

    '●白が選択された場合の検索キー生成処理

    Private Sub white_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)

        '検索キーは「FFFFFF」のみ。
        myValue_16 = "FFFFFF"

        'スライダーの値を初期化。
        Slider1.Value = 0

        '検索キー入力ボックス中の11個の花を表示。
        keyFlower1.Visibility = Windows.Visibility.Visible
        keyFlower2.Visibility = Windows.Visibility.Visible
        keyFlower3.Visibility = Windows.Visibility.Visible
        keyFlower4.Visibility = Windows.Visibility.Visible
        keyFlower5.Visibility = Windows.Visibility.Visible
        keyFlower6.Visibility = Windows.Visibility.Visible
        keyFlower7.Visibility = Windows.Visibility.Visible
        keyFlower8.Visibility = Windows.Visibility.Visible
        keyFlower9.Visibility = Windows.Visibility.Visible
        keyFlower10.Visibility = Windows.Visibility.Visible
        keyFlower11.Visibility = Windows.Visibility.Visible

        '検索キー入力ボックス中の11個の花の色と，ルーペ中の2個花の色を白に変更。
        Dim searchKeyColorW As SolidColorBrush = New SolidColorBrush
        searchKeyColorW.Color = Color.FromArgb(255, 255, 255, 255)
        keyFlower1.Background = searchKeyColorW
        keyFlower2.Background = searchKeyColorW
        keyFlower3.Background = searchKeyColorW
        keyFlower4.Background = searchKeyColorW
        keyFlower5.Background = searchKeyColorW
        keyFlower6.Background = searchKeyColorW
        keyFlower7.Background = searchKeyColorW
        keyFlower8.Background = searchKeyColorW
        keyFlower9.Background = searchKeyColorW
        keyFlower10.Background = searchKeyColorW
        keyFlower11.Background = searchKeyColorW
        miniFlower1.Fill = searchKeyColorW
        miniFlower2.Fill = searchKeyColorW
    End Sub


    '●黒が選択された場合の検索キー生成処理

    Private Sub black_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)

        '検索キーの値は「000000」のみ。
        myValue_16 = "000000"

        'スライダーの値を初期化。
        Slider1.Value = 0

        '検索キー入力ボックス中の11個の花を表示。
        keyFlower1.Visibility = Windows.Visibility.Visible
        keyFlower2.Visibility = Windows.Visibility.Visible
        keyFlower3.Visibility = Windows.Visibility.Visible
        keyFlower4.Visibility = Windows.Visibility.Visible
        keyFlower5.Visibility = Windows.Visibility.Visible
        keyFlower6.Visibility = Windows.Visibility.Visible
        keyFlower7.Visibility = Windows.Visibility.Visible
        keyFlower8.Visibility = Windows.Visibility.Visible
        keyFlower9.Visibility = Windows.Visibility.Visible
        keyFlower10.Visibility = Windows.Visibility.Visible
        keyFlower11.Visibility = Windows.Visibility.Visible

        '検索キー入力ボックス中の11個の花の色と，ルーペ中の2個花の色を黒に変更。
        Dim searchKeyColorB As SolidColorBrush = New SolidColorBrush
        searchKeyColorB.Color = Color.FromArgb(255, 0, 0, 0)
        keyFlower1.Background = searchKeyColorB
        keyFlower2.Background = searchKeyColorB
        keyFlower3.Background = searchKeyColorB
        keyFlower4.Background = searchKeyColorB
        keyFlower5.Background = searchKeyColorB
        keyFlower6.Background = searchKeyColorB
        keyFlower7.Background = searchKeyColorB
        keyFlower8.Background = searchKeyColorB
        keyFlower9.Background = searchKeyColorB
        keyFlower10.Background = searchKeyColorB
        keyFlower11.Background = searchKeyColorB
        miniFlower1.Fill = searchKeyColorB
        miniFlower2.Fill = searchKeyColorB
    End Sub

    '●スライダーにより色を選択した場合の，検索キー生成処理。

    Private Sub Slider1_ValueChanged(ByVal sender As Object, ByVal e As System.Windows.RoutedPropertyChangedEventArgs(Of Double))

        '検索キー入力ボックス中の11個の花を表示。
        keyFlower1.Visibility = Windows.Visibility.Visible
        keyFlower2.Visibility = Windows.Visibility.Visible
        keyFlower3.Visibility = Windows.Visibility.Visible
        keyFlower4.Visibility = Windows.Visibility.Visible
        keyFlower5.Visibility = Windows.Visibility.Visible
        keyFlower6.Visibility = Windows.Visibility.Visible
        keyFlower7.Visibility = Windows.Visibility.Visible
        keyFlower8.Visibility = Windows.Visibility.Visible
        keyFlower9.Visibility = Windows.Visibility.Visible
        keyFlower10.Visibility = Windows.Visibility.Visible
        keyFlower11.Visibility = Windows.Visibility.Visible

        'スライダーの中央の色相値から5を減算して，前後5色の初めの色から取得できるようにする。
        Dim myX As Integer = CInt(Slider1.Value)
        Dim myColorAngle As Integer
        myColorAngle = myX - 5

        'R，G，B値を表す各々の変数を宣言。
        Dim myValueR, myValueG, myValueB As Integer

        '11色を取得していくため，カウンタ用変数iを宣言。11回，検索キー生成処理を繰り返す。

        For i As Integer = 1 To 11

            '色相の値から，R，G，Bの各々の値を計算。
            If myX >= 0 And myX <= 60 Then
                myValueR = 255 * 2 - CInt(255 * myColorAngle / 60)
                myValueG = 255 * 2 - CInt(255 * (120 - myColorAngle) / 60)
                myValueB = 255 * 2 - CInt(255 * (120 + myColorAngle) / 60)
            ElseIf myX > 60 And myX <= 120 Then
                myValueR = 255 * 2 - CInt(255 * myColorAngle / 60)
                myValueG = 255 * 2 - CInt(255 * (120 - myColorAngle) / 60)
                myValueB = 255 * 2 - CInt(255 * (240 - myColorAngle) / 60)
            ElseIf myX > 120 And myX <= 180 Then
                myValueR = 255 * 2 - CInt(255 * myColorAngle / 60)
                myValueG = 255 * 2 - CInt(255 * -(120 - myColorAngle) / 60)
                myValueB = 255 * 2 - CInt(255 * (240 - myColorAngle) / 60)
            ElseIf myX > 180 And myX <= 240 Then
                myValueR = 255 * 2 - CInt(255 * (360 - myColorAngle) / 60)
                myValueG = 255 * 2 - CInt(255 * -(120 - myColorAngle) / 60)
                myValueB = 255 * 2 - CInt(255 * (240 - myColorAngle) / 60)
            ElseIf myX > 240 And myX <= 300 Then
                myValueR = 255 * 2 - CInt(255 * (360 - myColorAngle) / 60)
                myValueG = 255 * 2 - CInt(255 * -(120 - myColorAngle) / 60)
                myValueB = 255 * 2 - CInt(255 * (myColorAngle - 240) / 60)
            ElseIf myX > 300 And myX <= 360 Then
                myValueR = 255 * 2 - CInt(255 * (360 - myColorAngle) / 60)
                myValueG = 255 * 2 - CInt(255 * (480 - myColorAngle) / 60)
                myValueB = 255 * 2 - CInt(255 * (myColorAngle - 240) / 60)
            End If

            '上限下限値を設定して，下は0，上は255とする。
            If myValueR > 255 Then
                myValueR = 255
            ElseIf myValueR < 0 Then
                myValueR = 0
            End If

            If myValueG > 255 Then
                myValueG = 255
            ElseIf myValueG < 0 Then
                myValueG = 0
            End If

            If myValueB > 255 Then
                myValueB = 255
            ElseIf myValueB < 0 Then
                myValueB = 0
            End If

            'R・G・Bの各値を，RGBを表す16進数に変換する
            'R，G，Bの各々の値を16進数に変換。_2には2桁目，_1に1桁目を代入。

            Dim R_16_2, R_16_1, G_16_2, G_16_1, B_16_2, B_16_1 As Integer

            R_16_2 = CInt(Int(myValueR / 16))
            R_16_1 = myValueR - (R_16_2 * 16)
            G_16_2 = CInt(Int(myValueG / 16))
            G_16_1 = myValueG - (G_16_2 * 16)
            B_16_2 = CInt(Int(myValueB / 16))
            B_16_1 = myValueB - (B_16_2 * 16)

            'R，G，Bの各々の値を16進数に変換したものを連結する。
            myValue_16 = CType(R_16_2 & "," & R_16_1 & "," & G_16_2 & "," & G_16_1 & "," & B_16_2 & "," & B_16_1, String)

            '16進数では10以上の場合A～Fで表わされるので，これを置換する。
            myValue_16 = Replace(myValue_16, "10", "A")
            myValue_16 = Replace(myValue_16, "11", "B")
            myValue_16 = Replace(myValue_16, "12", "C")
            myValue_16 = Replace(myValue_16, "13", "D")
            myValue_16 = Replace(myValue_16, "14", "E")
            myValue_16 = Replace(myValue_16, "15", "F")
            myValue_16 = Replace(myValue_16, ",", "")

            '前5色＋メインカラー1色＋後5色の計11個の検索キーを格納する。
            colorArea(i) = myValue_16

            '●検索キーの色を花の形で表示する処理
            'XAMLの花の色に適用するバイト型の値を変数に格納。

            Dim suggestColorRByte As Byte = CType(myValueR, Byte)
            Dim suggestColorR() As Byte = New Byte(11) {}
            suggestColorR(i) = suggestColorRByte

            Dim suggestColorGByte As Byte = CType(myValueG, Byte)
            Dim suggestColorG() As Byte = New Byte(11) {}
            suggestColorG(i) = suggestColorGByte

            Dim suggestColorBByte As Byte = CType(myValueB, Byte)
            Dim suggestColorB() As Byte = New Byte(11) {}
            suggestColorB(i) = suggestColorBByte

            '検索キー入力ボックス中の11色，ルーペの中の最初の色（1の時）最後の色（11の時）を変更。

            If i = 1 Then
                Dim searchKeyColor1 As SolidColorBrush = New SolidColorBrush
                searchKeyColor1.Color = Color.FromArgb(255, suggestColorR(1), suggestColorG(1), suggestColorB(1))
                keyFlower1.Background = searchKeyColor1
                miniFlower1.Fill = searchKeyColor1
            ElseIf i = 2 Then
                Dim searchKeyColor2 As SolidColorBrush = New SolidColorBrush
                searchKeyColor2.Color = Color.FromArgb(255, suggestColorR(2), suggestColorG(2), suggestColorB(2))
                keyFlower2.Background = searchKeyColor2
            ElseIf i = 3 Then
                Dim searchKeyColor3 As SolidColorBrush = New SolidColorBrush
                searchKeyColor3.Color = Color.FromArgb(255, suggestColorR(3), suggestColorG(3), suggestColorB(3))
                keyFlower3.Background = searchKeyColor3
            ElseIf i = 4 Then
                Dim searchKeyColor4 As SolidColorBrush = New SolidColorBrush
                searchKeyColor4.Color = Color.FromArgb(255, suggestColorR(4), suggestColorG(4), suggestColorB(4))
                keyFlower4.Background = searchKeyColor4
            ElseIf i = 5 Then
                Dim searchKeyColor5 As SolidColorBrush = New SolidColorBrush
                searchKeyColor5.Color = Color.FromArgb(255, suggestColorR(5), suggestColorG(5), suggestColorB(5))
                keyFlower5.Background = searchKeyColor5
            ElseIf i = 6 Then
                Dim searchKeyColor6 As SolidColorBrush = New SolidColorBrush
                searchKeyColor6.Color = Color.FromArgb(255, suggestColorR(6), suggestColorG(6), suggestColorB(6))
                keyFlower6.Background = searchKeyColor6
            ElseIf i = 7 Then
                Dim searchKeyColor7 As SolidColorBrush = New SolidColorBrush
                searchKeyColor7.Color = Color.FromArgb(255, suggestColorR(7), suggestColorG(7), suggestColorB(7))
                keyFlower7.Background = searchKeyColor7
            ElseIf i = 8 Then
                Dim searchKeyColor8 As SolidColorBrush = New SolidColorBrush
                searchKeyColor8.Color = Color.FromArgb(255, suggestColorR(8), suggestColorG(8), suggestColorB(8))
                keyFlower8.Background = searchKeyColor8
            ElseIf i = 9 Then
                Dim searchKeyColor9 As SolidColorBrush = New SolidColorBrush
                searchKeyColor9.Color = Color.FromArgb(255, suggestColorR(9), suggestColorG(9), suggestColorB(9))
                keyFlower9.Background = searchKeyColor9
            ElseIf i = 10 Then
                Dim searchKeyColor10 As SolidColorBrush = New SolidColorBrush
                searchKeyColor10.Color = Color.FromArgb(255, suggestColorR(10), suggestColorG(10), suggestColorB(10))
                keyFlower10.Background = searchKeyColor10
            ElseIf i = 11 Then
                Dim searchKeyColor11 As SolidColorBrush = New SolidColorBrush
                searchKeyColor11.Color = Color.FromArgb(255, suggestColorR(11), suggestColorG(11), suggestColorB(11))
                keyFlower11.Background = searchKeyColor11
                miniFlower2.Fill = searchKeyColor11
            End If

            '以上の処理を，配列の個数分，11回繰り返す。
            '1を加算して次の1°について検索キーの生成処理を行う。
            myColorAngle = myColorAngle + 1
        Next i

    End Sub
End Class